diff --git a/src/django_scrypt_fmt_plug.c b/src/django_scrypt_fmt_plug.c
index 096c754a7a..04ebd7b40e 100644
--- a/src/django_scrypt_fmt_plug.c
+++ b/src/django_scrypt_fmt_plug.c
@@ -196,11 +196,14 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 	for (index = 0; index < count; index++)
 #endif
 	{
-		crypto_scrypt((unsigned char*)saved_key[index], strlen((char*)saved_key[index]),
+		if (crypto_scrypt((unsigned char*)saved_key[index], strlen((char*)saved_key[index]),
 				cur_salt->salt, strlen((char*)cur_salt->salt),
 				(1ULL) << cur_salt->N, cur_salt->r,
 				cur_salt->p, (unsigned char*)crypt_out[index],
-				BINARY_SIZE);
+				BINARY_SIZE) == -1)
+		{
+			memset(crypt_out[index], 0, sizeof(crypt_out[index]));
+		}
 	}
 	return count;
 }
